import pygame, thorpy

def mousemotion_func(event, game):
    x,y = event.pos
    if game.grid.frame.x <= x <= game.grid.frame.right:
        x,y = game.grid.get_coord_at_pix((event.pos[0], game.e_g.get_rect().centery))
        if x != game.column:
            if 0 <= x < game.board.nx:
                game.set_column(x)
    else:
        game.set_column(None)


def set_grid_reactions(game):
    reac_mousemotion = thorpy.Reaction(pygame.MOUSEMOTION, mousemotion_func,
                                        params={"game":game})
    reac_unpress = thorpy.ConstantReaction(pygame.MOUSEBUTTONUP, game.put,
                                        {"button":thorpy.parameters.LEFT_CLICK_BUTTON})
    reac_space = thorpy.ConstantReaction(pygame.KEYUP, game.put_ia)
    reac_unput = thorpy.ConstantReaction(pygame.KEYUP, game.board.unput,
                                            {"key":pygame.K_u},
                                            {"k":1})
    game.e_g.add_reaction(reac_mousemotion)
    game.e_g.add_reaction(reac_unpress)
    game.e_g.add_reaction(reac_space)
    game.e_g.add_reaction(reac_unput)

